package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.TypeHotBo;
import org.dromara.system.domain.vo.TypeHotVo;
import org.dromara.system.domain.TypeHot;
import org.dromara.system.mapper.TypeHotMapper;
import org.dromara.system.service.ITypeHotService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author Lion Li
 * @date 2024-12-16
 */
@RequiredArgsConstructor
@Service
public class TypeHotServiceImpl implements ITypeHotService {

    private final TypeHotMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     */
    @Override
    public TypeHotVo queryById(String typeId){
        return baseMapper.selectVoById(typeId);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public TableDataInfo<TypeHotVo> queryPageList(TypeHotBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TypeHot> lqw = buildQueryWrapper(bo);
        Page<TypeHotVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public List<TypeHotVo> queryList(TypeHotBo bo) {
        LambdaQueryWrapper<TypeHot> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TypeHot> buildQueryWrapper(TypeHotBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TypeHot> lqw = Wrappers.lambdaQuery();
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     */
    @Override
    public Boolean insertByBo(TypeHotBo bo) {
        TypeHot add = MapstructUtils.convert(bo, TypeHot.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setTypeId(add.getTypeId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     */
    @Override
    public Boolean updateByBo(TypeHotBo bo) {
        TypeHot update = MapstructUtils.convert(bo, TypeHot.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TypeHot entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除【请填写功能名称】
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
